import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import ict11.*;

public class AESApplet extends JApplet implements ActionListener {

	JButton encrypt,decrypt,help;
	JTextField keyField;
	JTextArea messageArea;
	JLabel statusBar;

	public void init() {
		encrypt = new JButton("Encrypt");
		decrypt = new JButton("Decrypt");
		help = new JButton("Help");
		encrypt.addActionListener(this);
		decrypt.addActionListener(this);
		help.addActionListener(this);

		keyField = new JTextField(200); 
		messageArea = new JTextArea(15,200);

		Container con = this.getContentPane();
		con.setLayout(new BorderLayout());

		JPanel topPan = new JPanel(new GridLayout(0,1));
		topPan.add(keyField);

		JPanel butPan = new JPanel(new GridLayout(0,3));
		butPan.add(encrypt);
		butPan.add(decrypt);
		butPan.add(help);
		topPan.add(butPan);

		con.add(topPan,BorderLayout.NORTH);
		con.add(messageArea,BorderLayout.CENTER);

		statusBar=new JLabel("Enter Key and Message");
		con.add(statusBar,BorderLayout.SOUTH);

		setSize(400,400);
		setVisible(true);
	}



	public void actionPerformed(ActionEvent ev) {
		if (ev.getSource()==encrypt) {
			String message = messageArea.getText();
			String key = keyField.getText();
			String cipher = CallRijndael.encrypt(key,message);
			messageArea.setText(cipher);
			statusBar.setText("Text area now contains ciphertext.");
		}
		else if (ev.getSource()==decrypt) {			String message = messageArea.getText();
			String key = keyField.getText();
			String plain = CallRijndael.decrypt(key,message);
			messageArea.setText(plain);
			statusBar.setText("Text area now contains plaintext.");	
		}
		else if (ev.getSource()==help) {
			if (ev.getActionCommand().equals("Help")) {
				helpTempText=messageArea.getText();
				messageArea.setText(helpText);
				help.setText("Close Help");
				encrypt.setEnabled(false);
				decrypt.setEnabled(false);
			}
			else {
				messageArea.setText(helpTempText);
				help.setText("Help");
				encrypt.setEnabled(true);
				decrypt.setEnabled(true);
			}
		}
	}

	String helpTempText="";
	String helpText=
	"The key should be entered in the above text field in hex form.\r\n"
   +"It should contain 16, 24 or 32 characters.\r\n\r\n"
   +"Paste or type the message (plain or cipher text) into the large text \r\n"
   +"area. Click on the encrypt button or the decrypt button accordingly.\r\n\r\n"
   +"If either a key or ciphertext is not correct, this may result\r\n"
   +"in an unfriendly error message. I will attempt to make this \r\n"
   +"nicer for the near future.";
}
