import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import ict11.*;

public class AESAppletNoSwing extends Applet implements ActionListener {

	Button encrypt,decrypt,help;
	TextField keyField;
	TextArea messageArea;
	Label statusBar;

	public void init() {
		encrypt = new Button("Encrypt");
		decrypt = new Button("Decrypt");
		help = new Button("Help");
		encrypt.addActionListener(this);
		decrypt.addActionListener(this);
		help.addActionListener(this);

		keyField = new TextField(200); 
		messageArea = new TextArea(15,200);

		setLayout(new BorderLayout());

		Panel topPan = new Panel(new GridLayout(0,1));
		topPan.add(keyField);

		Panel butPan = new Panel(new GridLayout(0,3));
		butPan.add(encrypt);
		butPan.add(decrypt);
		butPan.add(help);
		topPan.add(butPan);

		add(topPan,BorderLayout.NORTH);
		add(messageArea,BorderLayout.CENTER);

		statusBar=new Label("Enter Key and Message");
		add(statusBar,BorderLayout.SOUTH);

		setSize(400,400);
		setVisible(true);
	}



	public void actionPerformed(ActionEvent ev) {
		if (ev.getSource()==encrypt) {
			String message = messageArea.getText();
			String key = keyField.getText();
			String cipher = CallRijndael.encrypt(key,message);
			messageArea.setText(cipher);
			statusBar.setText("Text area now contains ciphertext.");
		}
		else if (ev.getSource()==decrypt) {			String message = messageArea.getText();
			String key = keyField.getText();
			String plain = CallRijndael.decrypt(key,message);
			messageArea.setText(plain);
			statusBar.setText("Text area now contains plaintext.");	
		}
		else if (ev.getSource()==help) {
			if (ev.getActionCommand().equals("Help")) {
				helpTempText=messageArea.getText();
				messageArea.setText(helpText);
				help.setLabel("Close Help");
				encrypt.setEnabled(false);
				decrypt.setEnabled(false);
			}
			else {
				messageArea.setText(helpTempText);
				help.setLabel("Help");
				encrypt.setEnabled(true);
				decrypt.setEnabled(true);
			}
		}
	}

	String helpTempText="";
	String helpText=
	"The key should be entered in the above text field in hex form.\r\n"
   +"It should contain 32, 48 or 64 characters.\r\n\r\n"
   +"Paste or type the message (plain or cipher text) into the large text \r\n"
   +"area. Click on the encrypt button or the decrypt button accordingly.\r\n\r\n"
   +"If either a key or ciphertext is not correct, this may result\r\n"
   +"in an unfriendly error message. I will attempt to make this \r\n"
   +"nicer for the near future.";
}
