package ict11;

import java.math.BigInteger;
import ict11.elgamal.*;

public class CallElGamal {

	public static String encrypt(String key, String message) {
		ElGamalPublicKey elkey =null;
		try {
			elkey = new ElGamalPublicKey(key);
		}
		catch (Exception e) {
			return "There was a problem with the private key. Encryption stopped";
		}
		EncryptedMessage enc = Wrapper.encrypt(message,elkey);
		return enc.toString();
	}

	public static String decrypt(String key, String message) {
		ElGamalPrivateKey elkey=null;
		try {
			elkey = new ElGamalPrivateKey(key);
			System.out.println(elkey);
		}
		catch (Exception e) {
			return "There was a problem with the private key. Decryption stopped";
		}
		EncryptedMessage enc = new EncryptedMessage(message);
		return Wrapper.decrypt(enc,elkey);
	}

	public static void main(String [] args) {
		String message = "This is a little message. It will test to see if \r\n" +
						"blocking and encrypting and then doing the reverse is going\r\n"+
						"work.  We'll just have to wait and see";
		String prkey = "ElGamalPrivate:(936179,283089,580894)";
		String pukey = "ElGamalPublic:(936179,283089,595150)";
		System.out.println(message);
		String hex = encrypt(pukey, message);
		System.out.println("\r\n"+hex);
		String output = decrypt(prkey,hex);
		System.out.println(output);
	}


}
