package ict11;

import ict11.rijndael.Rijndael;
import java.util.StringTokenizer;

public class CallRijndael {

	public static String encrypt(String ky, String message) {
		int [] rkey = EncryptionTools.readHexArray(ky);

		//First pad the message to be an exact number of blocks

		while (message.length() % 16 != 0) {
			message = message + " ";
		}

		//Break into blocks, encrypt and add to output
		StringBuffer buf = new StringBuffer();
		for (int i=0; i<message.length(); i=i+16) {
			buf.append(Rijndael.encryptBlock(message.substring(i,i+16), rkey) + "\r\n");
		}

		return buf.toString();	}

	public static String decrypt(String key, String message) {
		int [] rkey = EncryptionTools.readHexArray(key);
		StringTokenizer st = new StringTokenizer(message,"\r\n");
		StringBuffer buf = new StringBuffer();
		while (st.hasMoreTokens()) {
			String block = (String) st.nextToken();
			buf.append(Rijndael.decryptBlock(block,rkey));
		}		
		return buf.toString();
	}

	public static void main(String [] args) {
		String message = "This is a little message. It will test to see if \r\n" +
						"blocking and encrypting and then doing the reverse is going\r\n"+
						"work.  We'll just have to wait and see";
		String key = "00010203050607080A0B0C0D0F10111214151617191A1B1C1E1F202123242526";
		System.out.println(message);
		String hex = encrypt(key, message);
		System.out.println("\r\n"+hex);
		String output = decrypt(key,hex);
		System.out.println(output);
	}

}
