package ict11;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.Enumeration;
import ict11.elgamal.*;

public class GenerateElGamalKeyServlet extends HttpServlet { 
	/**
	 * Handle the HTTP GET method by building a simple web page.
	 */
	public void doGet (HttpServletRequest request,
                	   HttpServletResponse response)
        throws ServletException, IOException {
		PrintWriter		out;
		String	title = "Generating a public-private key pair.";
   	
		// set content type and other response header fields first
		response.setContentType("text/html");

		// then write the data of the response
		out = response.getWriter();

		out.println("<html><head><title>");
		out.println(title);
		out.println("</title></head><body>");
		int order = 1048;
		try {
			order = Integer.parseInt(request.getParameter("order"));
		}
		catch (Exception e) {
			out.println("Using defualt key size.<br />");
		}
		out.println("Key size: "+order);
	
		ElGamalPrivateKey priv = ElGamalKeyGenerator.generate(order);
		ElGamalPublicKey pub = priv.publicKey;
	
		out.println("The public key is: <br />");
		out.println(pub.toString()+"<br />");
		out.println("The private key is: <br />");
		out.println(priv.toString()+"<br />");

		out.println();
		out.println("</body></html>");
		out.close();
	}
}
