import java.io.*;

/**
 * Decrypts a file, using a keyfile, ciphertext file, and output file
 */

public class DecryptEl {

	public static String readIt(String file) throws Exception{
		BufferedReader in = null;
		StringBuffer buf = new StringBuffer();
		in = new BufferedReader(new FileReader(file));
		String line = in.readLine();
		while (line!=null && line.length()>0) {
			buf.append(line);
			line = in.readLine();
		}
		in.close();
		return buf.toString();
	}

	public static void decryptIt(String ctFile, String kFile, String oFile) {
		EncryptedMessage ciphertext = null;
		try { 
			ObjectInputStream in = new ObjectInputStream(new FileInputStream(ctFile));
			ciphertext = (EncryptedMessage) in.readObject();
			in.close();
		}
		catch (Exception e) {
			System.out.println("Trouble with ciphertext file.\r\n"+e.toString());
			return;
		}
		
		ElGamalPrivateKey priKey=null;
		try {
			priKey = new ElGamalPrivateKey(readIt(kFile));
		}
		catch (Exception e) {
			System.out.println("Trouble with key file.\r\n"+e.toString());
			return;
		}

		String dec = Wrapper.decrypt(ciphertext, priKey);
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(oFile));
			out.write(dec);
			out.close();
		}
		catch (Exception e) {
			System.out.println("Trouble with output file.\r\n"+e.toString());
			return;
		}
	}

	public static void main (String [] args) {
		//initialize plaintext,key and output filenames
		
		String ctf="";
		String kf="";
		String of="";
		//now get them from the command line
		try {
			ctf=args[0];
			kf=args[1];
			of=args[2];
		}
		//give abuse if the names were not there
		catch(Exception e) {
			System.out.println("EncryptEl <message file> <keyfile> <output file>");
			//get out of this program quick
			return;
		}

		//If all is well, all is well
		decryptIt(ctf,kf,of);
	}
}