package ict11.elgamal;

import java.math.BigInteger;
import java.util.Random;

public class ElGamalKeyGenerator {

	public static ElGamalPrivateKey generate(int order) {
		Random rnd = new Random();
		BigInteger p = new BigInteger(order,50,rnd);

		BigInteger alpha = new BigInteger(order, rnd);

		BigInteger a = new BigInteger(order, rnd);

		while ((p.compareTo(alpha) < 0) || 
				(p.subtract(BigInteger.valueOf(2)).compareTo(a) < 0)) {
			alpha = new BigInteger(order, rnd);
			a = new BigInteger(order, rnd);
		}

		return new ElGamalPrivateKey(p,alpha,a);
	}

	public static void main (String []args) {
		int order=0;
		try {
			order = Integer.parseInt(args[0]);
		}
		catch (Exception r) {
			System.out.println("Specify the order for the key. E.g. ElGamalKeyGenerator 25");
			return;
		}

		ElGamalPrivateKey prk = generate(order);

//		System.out.println(prk.toString(1));
//		System.out.println();
		System.out.println(prk);
		System.out.println(prk.publicKey);
	}
}
