package ict11.elgamal;

import java.math.BigInteger;
import java.util.StringTokenizer;

public class ElGamalPublicKey {

	public BigInteger p;
	public BigInteger alpha;
	public BigInteger alphaA;
	public ElGamalPublicKey(BigInteger p, BigInteger alpha, BigInteger alphaA) {
		this.p=p;
		this.alpha=alpha;
		this.alphaA=alphaA;
	}

	public ElGamalPublicKey(String key) throws Exception {
		StringTokenizer st = new StringTokenizer(key,"(,)");
		String preamble = st.nextToken();
		p = new BigInteger(st.nextToken());
		alpha = new BigInteger(st.nextToken());
		alphaA = new BigInteger(st.nextToken());
	}

	public String toString() {
		return "ElGamalPublic:("+p.toString()+","+alpha.toString()+","+alphaA.toString()+")";
	}

	public String toString(int i) {
		return "Public Key:\r\np:\t"+p.toString()+"\r\nalpha:\t"
				+alpha.toString()+"\r\nal^a:\t"+alphaA.toString();
	}

	public static void main(String []args) {
		if (args.length==0) {
			System.out.println("Specify a public key to parse");
			return;
		}
		try {
			ElGamalPublicKey p = new ElGamalPublicKey(args[0]);
			System.out.println("Correctly Parsed:\r\n"+p.toString());
		}
		catch (Exception e) {
			System.out.println("Could not parse\r\n"+e.toString());
		}
	}


}
