import java.io.*;

/**
 * Encrypts a file, using a keyfile, plaintext file, and output file
 */

public class EncryptEl {

	public static String readIt(String file) throws Exception{
		BufferedReader in = null;
		StringBuffer buf = new StringBuffer();
		in = new BufferedReader(new FileReader(file));
		String line = in.readLine();
		while (line!=null) {
			buf.append(line+"\r\n");
			line = in.readLine();
		}
		in.close();
		return buf.toString();
	}

	public static void encryptIt(String ptFile, String kFile, String oFile) {
		String plaintext = "";
		try { 
			plaintext = readIt(ptFile);
		}
		catch (Exception e) {
			System.out.println("Trouble with plaintext file.\r\n"+e.toString());
			return;
		}
		ElGamalPublicKey pubKey=null;
		try {
			pubKey = new ElGamalPublicKey(readIt(kFile));
		}
		catch (Exception e) {
			System.out.println("Trouble with key file.\r\n"+e.toString());
			return;
		}

		EncryptedMessage enc = Wrapper.encrypt(plaintext, pubKey);
		try {
			ObjectOutputStream out = new ObjectOutputStream(new
					FileOutputStream(oFile));
			out.writeObject(enc);
			out.close();
		}
		catch (Exception e) {
			System.out.println("Trouble with output file.\r\n"+e.toString());
			return;
		}
	}

	public static void main (String [] args) {
		//initialize plaintext,key and output filenames		
		String ptf="";
		String kf="";
		String of="";
		//now get them from the command line
		try {
			ptf=args[0];
			kf=args[1];
			of=args[2];
		}
		//give abuse if the names were not there
		catch(Exception e) {
			System.out.println("EncryptEl <message file> <keyfile> <output file>");
			//get out of this program quick
			return;
		}

		//If all is well, all is well
		encryptIt(ptf,kf,of);
	}
}
