package ict11.elgamal;

import java.math.BigInteger;
import java.io.*;
import java.util.StringTokenizer;

public class EncryptedMessage {

	public BigInteger [] gamma;
	public BigInteger [] delta;
	public EncryptedMessage(BigInteger [] gamma, BigInteger [] delta) {
		this.gamma = gamma;
		this.delta = delta;
	}
	
	public EncryptedMessage(String message) {
		StringTokenizer st = new StringTokenizer(message,"(){}[], \r\n");
		int blocks = st.countTokens()/2;

		//System.out.println("Blocks: "+blocks);

		gamma = new BigInteger[blocks];
		delta = new BigInteger[blocks];

		for (int i=0; i<delta.length; i++) {
			gamma[i] = new BigInteger(st.nextToken());
			delta[i] = new BigInteger(st.nextToken());
		}
	}

	public String toString() {
		StringBuffer buf = new StringBuffer();
		for (int i=0; i<gamma.length; i++) {
			buf.append("(");
			buf.append(gamma[i]);
			buf.append(",");
			buf.append(delta[i]);
			buf.append(")");
		}
		return buf.toString();
	}
	
}
