package ict11.elgamal;

import java.math.BigInteger;
import java.util.Vector;

/** 
 * This class adds methods that work with strings instead of arrays full of
 * BigIntegers. T
 */

public class Wrapper {

	public static EncryptedMessage encrypt(String message, ElGamalPublicKey key) {

		BigInteger [] plaintext = encodeMessage(message, key.p);

		return ElGamal.encrypt(plaintext, key);
	}
	public static String decrypt(EncryptedMessage ciphertext, ElGamalPrivateKey key) {
		
		BigInteger [] plaintext = ElGamal.decrypt(ciphertext, key);

		return decodeMessage(plaintext);

	}

	private static BigInteger [] encodeMessage(String message, BigInteger p) {
		byte [] m = message.getBytes();
		BigInteger [] mess = new BigInteger[m.length];
		for (int i=0; i<m.length; i++)
			mess[i] = BigInteger.valueOf(m[i]);
		return mess;
	}


	private static String decodeMessage(BigInteger [] plaintext) {
		byte[] m = new byte[plaintext.length];
		for (int i=0; i<m.length; i++)
			m[i] = (byte) plaintext[i].intValue();
		return new String(m);
	}

	public static void main(String  []args ) {
		int order=0;
		try {
			order = Integer.parseInt(args[0]);
		}
		catch (Exception r) {
			System.out.println("Specify the order for the key. E.g. ElGamalWrapper 25");
			return;
		}
		BigInteger p = ElGamalKeyGenerator.generate(order).getP();
		String test = "This is a short little message that is being used to \r\n"
					+ "test the damn encoder. We'll have to wait and see what\r\n"
					+ "happens. Oh! Isn't it exciting?";
		System.out.println(test+"\r\n\r\nwas to go to \r\n");
		System.out.println("\""+decodeMessage(encodeMessage(test,p))+"\"");
	}


}
